<script setup lang="ts">
import { ref, computed, watch, inject, PropType, defineProps } from 'vue';
import { useVuelidate } from '@vuelidate/core';
import { email } from '@vuelidate/validators';
import {
  JText,
  JContainer,
  JAppLogo,
  JFormControl,
  JTextField,
  JErrorMessages,
  JButton,
} from '@new-jira-clone/ui/src/components';
import { i18n } from '@new-jira-clone/libs/src/types';
import { minLength, required, getError } from '@/shared/utils';
import { type LoginByEmailForm } from '@/shared/api';
import { SuggestionToAuthLink } from '@/shared/ui';
import { pathConfig } from '@/shared';

const props = defineProps({
  submitForm: {
    type: Function as PropType<(form: LoginByEmailForm) => Promise<void>>,
    required: true,
  },
});

const $t = inject('$t') as i18n;

const rules = computed(() => ({
  email: {
    required,
    email,
    minLength: minLength(4),
  },
  password: {
    required,
    minLength: minLength(4),
  },
}));

const errorsMessages = ref<string[]>([]);

const loginForm = ref<LoginByEmailForm>({
  email: '',
  password: '',
});

const isSubmitForm = ref(false);

const v$ = useVuelidate(rules, loginForm.value);

const resetFormErrorsMessages = () => {
  errorsMessages.value = [];
};

const onSubmitForm = async () => {
  if (isSubmitForm.value) return;

  const isValidForm = await v$.value.$validate();

  if (isValidForm === false) return;

  try {
    isSubmitForm.value = true;
    await props.submitForm(loginForm.value);
  } catch (error) {
    errorsMessages.value = [String($t('response_form_error'))];
  } finally {
    isSubmitForm.value = false;
  }
};

const getEmailErrors = computed(() => getError(v$.value.email));
const getPasswordErrors = computed(() => getError(v$.value.password));

watch(v$, resetFormErrorsMessages);
</script>

<template>
  <JContainer class="login-form">
    <JAppLogo />

    <JText
      tag="h1"
      color="text"
      weight="normal"
      type="title-1"
      class="text-center"
    >
      {{ $t('login_page_title') }}
    </JText>
    <JText
      tag="p"
      weight="normal"
      type="text-1"
      color="text"
      class="text-center mb-4"
    >
      {{ $t('login_page_subtitle') }}
    </JText>

    <form @submit.prevent="onSubmitForm">
      <JFormControl>
        <template #label> {{ $t('email') }} </template>
        <JTextField
          v-model="loginForm.email"
          dense
          name="email"
          type="email"
          text-margin
          outlined
          :close-icon="false"
          @blur="v$.email.$touch()"
        >
          <template #info>
            <JErrorMessages
              data-test-email-error
              :error-messages="getEmailErrors"
            />
          </template>
        </JTextField>
      </JFormControl>

      <JFormControl>
        <template #label> {{ $t('password') }} </template>
        <JTextField
          v-model="loginForm.password"
          dense
          name="password"
          text-margin
          type="password"
          outlined
          :close-icon="false"
          @blur="v$.password.$touch()"
        >
          <template #info>
            <JErrorMessages
              data-test-password-error
              :error-messages="getPasswordErrors"
            />
          </template>
        </JTextField>
      </JFormControl>

      <JErrorMessages
        data-test-response-errors
        :error-messages="errorsMessages"
      />

      <JButton
        :loading="isSubmitForm"
        size="xs"
        class="submit-form-btn"
      >
        {{ $t('sign_in') }}
      </JButton>

      <SuggestionToAuthLink :to="pathConfig.register">
        {{ $t('dont_have_account') }}
      </SuggestionToAuthLink>
    </form>
  </JContainer>
</template>

<style lang="scss" scoped>
.submit-form-btn {
  margin-top: 24px;
  width: 100%;
}
</style>
